import sys
import os
import numpy as np
import time
#import arguments

import re

import cmath

import scipy as sp
import scipy.sparse as sparse
import scipy.sparse.linalg as splinalg
from scipy.io import netcdf

#from Scientific.IO.NetCDF import NetCDFFile as Dataset


def main(argv):

    in_dir = "/panfs/pandora/projects/3DGN/tests/summerproject2013/master/models/troll_001/datafiles";
    in_filename = "ST0755_02Tx003a_02Rx020a_data.nc";
    in_filepath = in_dir + "/" + in_filename;

    out_dir = in_dir;
    out_filename = "modified_" + in_filename;
    out_filepath = out_dir + "/" + out_filename;

    no_field_components = 5;    # in original data
    no_frequencies = 10;        # in original data


#   Data to extract:

    bool_field = np.array([1,0,0,0,0])
    bool_freqs = np.array([1,1,1,0,0,0,0,0,0,0])
    min_offset = np.array([1500.0,1500.0,1000.0,0,0,0,0,0,0,0])
    max_offset = np.array([9000.0,8000.0,6000.0,0,0,0,0,0,0,0])

#   Read netcdf file

    in_ncfile = netcdf.netcdf_file(in_filepath,'r')

    in_jsrc = in_ncfile.variables['jsrc']
    in_srcpos = in_ncfile.variables['srcpos']
    in_emf = in_ncfile.variables['emf']

#   Original dimensions
    no_field_components = 5
    no_frequencies = 10
    no_sources = in_srcpos.shape[0]/2/no_frequencies
    no_receivers = 1

    x_r = 524634.6
    y_r = 6734338.9
    z_r = 325.6

#   New dimensions
    out_no_field_components = 1
    out_no_frequencies = 3
    out_no_receivers = 1

    temp_jsrc = np.zeros([1,1])
    temp_srcpos = np.zeros([1,6])
    temp_emf = np.zeros([1,out_no_field_components])

    k = 0
    for freq in range(no_frequencies):
        if (bool_freqs[freq] == 1):
            for src in range(no_sources):
                for im in range(2):
                    l = freq*(no_sources*2) + 2*src + im
                    x_s = in_srcpos[l,0]
                    y_s = in_srcpos[l,1]
                    z_s = in_srcpos[l,2]
                    offset = np.sqrt((x_r - x_s)**2 + (y_r - y_s)**2 + (z_r - z_s)**2)
                    if ((offset > min_offset[freq]) and (offset < max_offset[freq])):
                        temp_emf = np.vstack((temp_emf,in_emf[l,[i for i in range(no_field_components) if bool_field[i]==1]]))
                        temp_jsrc = np.vstack((temp_jsrc,in_jsrc[l,:]))
                        temp_srcpos = np.vstack((temp_srcpos,in_srcpos[l,:]))

#   Write netcdf file

    out_ncfile = netcdf.netcdf_file(out_filepath,'w')

#    out_ncfile.createDimension('nsamp',temp_emf.shape[0])
#    out_ncfile.createDimension('jtrace',1)
#    out_ncfile.createDimension('strace',temp_srcpos.shape[1])
#    out_ncfile.createDimension('dtrace',temp_emf.shape[1])

    out_jsrc = out_ncfile.createVariable('jsrc',dtype('float32').char,('nsamp','jtrace'))
    out_srcpos = out_ncfile.createVariable('srcpos',dtype('float32').char,('nsamp','strace'))
    out_emf = out_ncfile.createVariable('emf',dtype('float32').char,('nsamp','dtrace'))

    out_jsrc[:] = temp_jsrc
    out_srcpos[:] = temp_srcpos
    out_emf[:] = temp_emf

    in_ncfile.close()
    out_ncfile.close()

main(sys.argv)
