####################################################
# Import txt file and plot the data in the columns #
####################################################

import sys
import os
import time
import cmath
import re

import numpy as np
import numpy.linalg as nplinalg

import mayavi
import mayavi.tools
import mayavi.tools.pipeline

from mayavi import mlab
# Core engine
#from mayavi.core.api import Engine
#from mayavi.core.ui.engine_view import EngineView
# Usual MayaVi imports
#from mayavi.sources.api import VTKXMLFileReader
#from mayavi.modelus.api import Outline, ScalarCutPlane, Streamline,
#ImagePlaneWidget

import scipy as sp
import scipy.sparse as sparse
import scipy.sparse.linalg as splinalg
from scipy.io import netcdf

import matplotlib as mpl
from mpl_toolkits.mplot3d import axes3d, Axes3D
import matplotlib.pyplot as pypl
from matplotlib.pyplot import figure, show, xlabel, ylabel


def main(argv):
# Plot contents of a solution txt file
# This file should be organized as
#
# iter col1     col2    * * *   coln
# 1    data11   data12          data1n
#
# *
# *
# *
#
# m    datam1   datam2          datamn

# Firs argument is the filname of the file containing the data
# Allways call from directory containing this file.
# Second argument is how many iterations to plot

    filepath = os.getcwd() + "/" + sys.argv[1]
    no_iter = int(float(sys.argv[2]))
    print no_iter == 1000
    data = np.genfromtxt(filepath,skip_header=1,dtype=float)

    file = open(filepath,'r')
    lines = file.readlines()
    file.close

    iterations          = data[:no_iter,0]
    current_misfit      = data[:no_iter,1]
    current_RMS         = data[:no_iter,2]
    proposed_RMS        = data[:no_iter,3]
    accept_probability  = data[:no_iter,4]
    accept_ratio        = data[:no_iter,5]
    temperature         = data[:no_iter,6]
    n                   = data[:no_iter,7]
    x_1                 = data[:no_iter,8]
    x_2                 = data[:no_iter,9]
    x_3                 = data[:no_iter,10]
    x_4                 = data[:no_iter,11]
    x_5                 = data[:no_iter,12]
    x_6                 = data[:no_iter,13]
    x_7                 = data[:no_iter,14]

    pypl.figure(1)

    pypl.subplot(911)
    pypl.plot(np.log10(x_1))

    pypl.subplot(912)
    pypl.plot(np.log10(x_2))

    pypl.subplot(913)
    pypl.plot(x_3)

    pypl.subplot(914)
    pypl.plot(x_4)

    pypl.subplot(915)
    pypl.plot(x_5)

    pypl.subplot(916)
    pypl.plot(x_6)

    pypl.subplot(917)
    pypl.plot(x_7)

    pypl.subplot(918)
    pypl.plot(np.log10(temperature))

    pypl.subplot(919)
    pypl.plot(np.log10(current_RMS))

    pypl.show()

main(sys.argv)
raw_input()
